untyped
global function ThiefV2Init

//possible keys for file

//["hasFocus","selectedPlayer","prevPlayer","nextPlayer","scoreboardBg","scoreboard","background","scoreboardOverlays","scoreboardElems",
//"header","footer","pingText","teamElems","highlightColumns","nameEndColumn","playerElems","scoreboardRUI","scoreboardUpdateCallback"]


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//READ HERE

//In order to change the keybind for copying a loadout, you need to change the letter in KEY_LETTER.
//I marked the line you need to apply the change in with an arrow: <-------------
//The default key is L.

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

entity selectedPlayer = null

bool hasFocus = false

void function ThiefV2Init()
{
	AddCallback_OnScoreboardUpdate(UpdateSelectedPlayer)
	RegisterButtonPressedCallback(KEY_L, StealFromPlayer) //<-------------
}


void function UpdateSelectedPlayer(SuperiorFile file)
{
	hasFocus = file.hasFocus
	selectedPlayer = expect entity(file.selectedPlayer)
}

void function StealFromPlayer(var pressedKey)
{
	//add IFs
	
	Assert( clGlobal.showingScoreboard )
	
	if(hasFocus)
	{
		////////////
		//SETTINGS//
		////////////
		
		int outputLoadoutIndex = 10 //The default value. This will determine into which loadout your target's loadout will be cloned. (0 is first, 9 is last, however i substract 1 every time so it's 1 to 10)
		int preferredPistolSlot = GetConVarInt("thiefv2_pref_pistol_slot")+2 //2 or 3, determines into which slot the pistol is copied if you set the next value to true.
		bool forcePreferredPistolSlot = true //If true, pistol will always be copied into your preferred slot. If false, it will copy it into the slot the person you're stealing from is using.
		
		////////////////
		//SETTINGS END//
		////////////////
		
		int chosenIndex = GetConVarInt("thiefv2_default_output")
		if(chosenIndex < 1 || chosenIndex > 10)
		{
			chosenIndex = 10
		}
		outputLoadoutIndex = chosenIndex
		entity child = selectedPlayer
		
		if (IsAlive(child))
		{
			
			if(child.IsTitan())
			{
			return
			}
			
			array<entity> mainWeapons = child.GetMainWeapons()
	
			if(mainWeapons.len() >2)
			{
				
				array<string> primaryweps = GetAllWeaponsByType( [ eItemTypes.PILOT_PRIMARY ] )
				array<string> secondaryweps = GetAllWeaponsByType( [ eItemTypes.PILOT_SECONDARY ] )
				array<string> ordnances = GetAllWeaponsByType( [ eItemTypes.PILOT_ORDNANCE ] )
				string proScreen = "pro_screen"
				
				int pistolcount = 0
				int ATweaponcount = 0
				
				int pistolIndex = 1
				//int ATweaponIndex = 2
				
				bool isFirstSlotFull = false
				bool isSecondSlotAvailable = true
				
				
				//PREP FOR WEAPON CHANGE
				//Pistols can only be swapped with other pistols, same goes for AT weapons
				//The thing below makes sure we always do it correctly
				//Logger.Info(GetPersistentLoadoutValue( GetLocalClientPlayer(), "pilot", (outputLoadoutIndex-1), "secondary" ))
				if(pistols.find(GetPersistentLoadoutValue( GetLocalClientPlayer(), "pilot", (outputLoadoutIndex-1), "secondary" )) == -1)
				{
					GetLocalClientPlayer().ClientCommand( "SwapSecondaryAndWeapon3PersistentLoadoutData " + (outputLoadoutIndex-1) )
				}
				//Logger.Info("Swapped into: " + GetPersistentLoadoutValue( GetLocalClientPlayer(), "pilot", (outputLoadoutIndex-1), "secondary" ))
				
				
				//PRIMARY
				if(primaryweps.find(mainWeapons[0].GetWeaponClassName()) != -1)
				{
					GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "primary" + " " + mainWeapons[0].GetWeaponClassName())
					
					if(mainWeapons[0].GetSkin() != 0)
					{
							GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "primaryCamoIndex" + " " + mainWeapons[0].GetCamo().tostring())
							GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "primarySkinIndex" + " " + mainWeapons[0].GetSkin().tostring())
					}
					//GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "primaryCamoIndex" + " " + mainWeapons[0].GetCamo().tostring())
	
					array <string> targetWeaponMods = mainWeapons[0].GetMods()
					clearMods("primary", outputLoadoutIndex)
					
					//since threat scope messes with the mods, i need to check if it's there first
					foreach(mod in targetWeaponMods)
					{
						if(allowedattachments.find(mod) != -1)
						{
							GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "primaryAttachment" + " " + mod)
							
							if(mod == "threat_scope")
							{
								isSecondSlotAvailable = false
							}
						}
					}
					
					foreach(mod in targetWeaponMods)
					{
						if(allowedweaponmods.find(mod) != -1)
						{
							if(!isFirstSlotFull)
							{
								GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "primaryMod1" + " " + mod)
								//SetCachedLoadoutValue(GetLocalClientPlayer(), "pilot",  (outputLoadoutIndex-1), "primaryMod1", mod)
								isFirstSlotFull = true
							}
							else if(isSecondSlotAvailable)
							{
								GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "primaryMod2" + " " + mod)
								//SetCachedLoadoutValue(GetLocalClientPlayer(), "pilot",  (outputLoadoutIndex-1), "primaryMod2", mod)
							}
						}
						if(proScreen.find(mod) != null)
						{
							GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "primaryMod3" + " " + mod)
							//SetCachedLoadoutValue(GetLocalClientPlayer(), "pilot",  (outputLoadoutIndex-1), "primaryMod3", mod)
						}
					}
					isFirstSlotFull = false
				}
				
				
				//SECONDARIES (AT AND PISTOLS)
				for(int k = 1; k < 3; k++)
				{
					if(secondaryweps.find(mainWeapons[k].GetWeaponClassName()) != -1)
					{
						if(pistols.find(mainWeapons[k].GetWeaponClassName()) != -1 && pistolcount == 0)
						{
							GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "secondary" + " " + mainWeapons[k].GetWeaponClassName())
							
							if(mainWeapons[k].GetSkin() != 0)
							{
								GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "secondaryCamoIndex" + " " + mainWeapons[k].GetCamo().tostring())
								GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "secondarySkinIndex" + " " + mainWeapons[k].GetSkin().tostring())
								//GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "secondaryCamoIndex" + " " + mainWeapons[k].GetCamo().tostring())
							}
							
							//GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "secondaryCamoIndex" + " " + mainWeapons[k].GetCamo())
							clearMods("secondary", outputLoadoutIndex)
							
							foreach(mod in mainWeapons[k].GetMods())
							{
								if(allowedweaponmods.find(mod) != -1)
								{
									if(!isFirstSlotFull)
									{
										GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "secondaryMod1" + " " + mod)
										isFirstSlotFull = true
									}
									else
									{
										GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "secondaryMod2" + " " + mod)
									}
								}
								if(proScreen.find(mod) != null)
								{
									GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "secondaryMod3" + " " + mod)
								}
							}
							isFirstSlotFull = false
							
							//Logger.Info("Pistol stolen!")
							pistolIndex = k
							pistolcount++
						}
						else if(ATweaponcount == 0)
						{
							GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "weapon3" + " " + mainWeapons[k].GetWeaponClassName())
							
							if(mainWeapons[k].GetSkin() != 0)
							{
								GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "weapon3CamoIndex" + " " + mainWeapons[k].GetCamo().tostring())
								GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "weapon3SkinIndex" + " " + mainWeapons[k].GetSkin().tostring())
								//GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "weapon3CamoIndex" + " " + mainWeapons[k].GetCamo().tostring())
							}
							
							//GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "weapon3CamoIndex" + " " + mainWeapons[k].GetCamo())
							clearMods("weapon3", outputLoadoutIndex)
							
							foreach(mod in mainWeapons[k].GetMods())
							{
								if(allowedweaponmods.find(mod) != -1)
								{
									if(!isFirstSlotFull)
									{
										GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "weapon3Mod1" + " " + mod)
										isFirstSlotFull = true
									}
									else
									{
										GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "weapon3Mod2" + " " + mod)
									}
								}
								if(proScreen.find(mod) != null)
								{
									GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "weapon3Mod3" + " " + mod)
								}
							}
							isFirstSlotFull = false
							
							//Logger.Info("AT Weapon stolen!")
							ATweaponcount++
						}
					}
				}
				
				
				if(pistolIndex == 2 && forcePreferredPistolSlot == false || forcePreferredPistolSlot == true && preferredPistolSlot == 3)
				{
					GetLocalClientPlayer().ClientCommand( "SwapSecondaryAndWeapon3PersistentLoadoutData " + (outputLoadoutIndex-1) )
				}
	
				
				//TACTICALS AND ORDNANCES
				if(child.GetOffhandWeapons().len() > 2)
				{
					//Logger.Info(child.GetOffhandWeapon(1).GetWeaponClassName())
					if(specialNames.find(child.GetOffhandWeapon(1).GetWeaponClassName()) != -1)
					{
						GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "suit" + " " + suitNames[specialNames.find(child.GetOffhandWeapon(1).GetWeaponClassName())])
						
						//Logger.Info("Tactical stolen!")
					}
					if(ordnances.find(child.GetOffhandWeapon(0).GetWeaponClassName()) != -1)
					{
						GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "ordnance" + " " + child.GetOffhandWeapon(0).GetWeaponClassName())
						
					}
				}	
				
				//PILOT KITS
				foreach (string key, int val in ePassives)
				{
					if(PlayerHasPassive(child, val))
					{
						if(passive1ReturnedNames.find(key) != -1)
						{
							GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "passive1" + " " + passive1Names[passive1ReturnedNames.find(key)])
							//Logger.Info("Kit 1 stolen!")
							
						}
						if(passive2ReturnedNames.find(key) != -1)
						{
							GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "passive2" + " " + passive2Names[passive2ReturnedNames.find(key)])
							//Logger.Info("Kit 2 stolen!")
							
						}
						//Logger.Info(key)
					}
				}
				
				
				//PILOT CAMO
				GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "camoIndex" + " " + child.GetCamo())
				
				
				return
			}
			
			else
			{
				return
			}
			
		}
	}
}

void function clearMods(string weaponType, int outputLoadoutIndex) 
{
	//Logger.Info("Func called! Clearing mods...")
	string emptyString = "\"\""
	GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + weaponType + "Mod1" + " " + emptyString)
	GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + weaponType + "Mod2" + " " + emptyString)
	GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + weaponType + "Mod3" + " " + emptyString)
	if(weaponType == "primary")
	{
		GetLocalClientPlayer().ClientCommand("SetPersistentLoadoutValue pilot " + (outputLoadoutIndex-1) + " " + "primaryAttachment" + " " + emptyString)
	}
	//GetLocalClientPlayer().ClientCommand(SetPilotLoadoutValue( shGlobal.cachedPilotLoadouts[ outputLoadoutIndex-1 ], weaponType + "Mod2", "" )) //fail, something about null
}

//consts again
array<string> allowedweaponmods = ["extended_ammo",
														"silencer",
														"ricochet",
														"quick_charge",
														"tactical_cdr_on_kill",
														"pas_fast_ads",
														"pas_fast_swap",
														"pas_fast_reload",
														"pas_run_and_gun"]
					array<string> allowedattachments = [
														"hcog",
														"redline_sight",
														"aog",
														"holosight",
														"scope_4x",
														"threat_scope",]
					array<string> pistols = ["mp_weapon_autopistol",
											"mp_weapon_semipistol",
											"mp_weapon_wingman"]							
					array<string> specialNames = [
												"mp_ability_cloak",
												"mp_ability_grapple",
												"mp_weapon_deployable_cover",
												"mp_ability_shifter",
												"mp_weapon_grenade_sonar",
												"mp_ability_heal",
												"mp_ability_holopilot"]
					array<string> suitNames = [
												"geist",
												"grapple",
												"heavy",
												"light",
												"medium",
												"nomad",
												"stalker"]
					array<string> passive1Names = ["pas_ordnance_pack",
													"pas_power_cell",
													"pas_fast_embark",
													"pas_fast_health_regen"]
					array<string> passive1ReturnedNames = ["PAS_ORDNANCE_PACK",
													"PAS_POWER_CELL",
													"PAS_FAST_EMBARK",
													"PAS_FAST_HEALTH_REGEN"]
					array<string> passive2Names = ["pas_stealth_movement",
												"pas_wallhang",
												"pas_ads_hover",
												"pas_enemy_death_icons",
												"pas_at_hunter"]	
					array<string> passive2ReturnedNames = ["PAS_STEALTH_MOVEMENT",
												"PAS_WALLHANG",
												"PAS_ADS_HOVER",
												"PAS_ENEMY_DEATH_ICONS",
												"PAS_AT_HUNTER"]
					array<string> atWeps = ["mp_weapon_mgl",
											"mp_weapon_defender",
											"mp_weapon_arc_launcher",
											"mp_weapon_rocket_launcher"]